## vitis-ai 1.3.2

=== Vitis-AI-Library/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License"); you may not
# use this file except in compliance with the License. You may obtain a copy of
# the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
# License for the specific language governing permissions and limitations under
# the License.
#
cmake_minimum_required(VERSION 3.5)
project(
  vitis_ai_library
  VERSION 1.3.1
  LANGUAGES C CXX)
include(${CMAKE_SOURCE_DIR}/cmake/XilinxCommon.cmake)

# ugly solution for search XRT library, xrt is built without proper rpath
# setting
link_directories("/opt/xilinx/xrt/lib")
# options
option(DISABLE_ALL "disable all libraries" OFF)
option(ENABLE_CLASSIFICATION "enable classification" OFF)
option(ENABLE_TFSSD "enable tfssd" OFF)
option(ENABLE_SSD "enable ssd" OFF)
option(ENABLE_FACEDETECT "enable face detection" OFF)
option(ENABLE_FACERECOG "enable face recog" OFF)
option(ENABLE_FACEDETECTRECOG "enable face detect recog" OFF)
option(ENABLE_FACEFEATURE "enable face feature" OFF)
option(ENABLE_FACEQUALITY5PT "enable face quality 5pt" OFF)
option(ENABLE_LANEDETECT "enable lane detection" OFF)
option(ENABLE_YOLOV2 "enable Yolov2" OFF)
option(ENABLE_YOLOV3 "enable Yolov3" OFF)
option(ENABLE_LANDMARK "enable landmark face-5pt" OFF)
option(ENABLE_SEGMENTATION "enable segmentation" OFF)
option(ENABLE_COVID19SEGMENTATION "enable covid19segmentation" OFF)
option(ENABLE_3DSEGMENTATION "enable 3dsegmentation" OFF)
option(ENABLE_REFINEDET "enable refinedet" OFF)
option(ENABLE_OPENPOSE "enable openpose" OFF)
option(ENABLE_HOURGLASS "enable hourglass" OFF)
option(ENABLE_POSEDETECT "enable pose detect" OFF)
option(ENABLE_REID "enable reid" OFF)
option(ENABLE_REIDTRACKER "enable reidtracker" OFF)

option(ENABLE_MULTITASK "enable multitask" OFF)
option(ENABLE_PLATEDETECT "enable platedetect" OFF)
option(ENABLE_PLATENUM "enable platenum" OFF)
option(ENABLE_PLATERECOG "enable platerecog" OFF)
option(ENABLE_CARPLATERECOG "enable carplaterecog" OFF)
option(ENABLE_OVERVIEW "enable overview" OFF)
option(ENABLE_GENERAL "enable general" OFF)
option(ENABLE_MEDICALSEGMENTATION "enable medicalsegmentation" OFF)
option(ENABLE_MEDICALDETECTION "enable medicaldetection" OFF)
option(ENABLE_POINTPILLARS "enable pointpillars" OFF)
option(ENABLE_RETINAFACE "enable retinaface" OFF)
option(ENABLE_CIFAR10CLASSIFICATION "enable cifar10classification" OFF)
option(ENABLE_MNISTCLASSIFICATION "enable mnistclassification" OFF)
option(ENABLE_MEDICALSEGCELL "enable medicalsegcell" OFF)

option(ENABLE_DPUCADX8G_RUNNER "enable DPUV1 Runner" OFF)
option(ENABLE_DPUCADF8H_RUNNER "enable DPUV3INT8 Runner" OFF)

set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${CMAKE_CURRENT_LIST_DIR}/cmake")
set(INSTALL_LIB_DIR lib)
set(INSTALL_BIN_DIR bin)
set(INSTALL_INCLUDE_DIR include)
set(INSTALL_CMAKE_DIR share/cmake/${PROJECT_NAME})

if(ENABLE_DPUCADX8G_RUNNER)
  # Enble supported models for DPUV1
  unset(DISABLE_ALL CACHE)
  unset(ENABLE_CLASSIFICATION CACHE)
  unset(ENABLE_FACEDETECT CACHE)
  unset(ENABLE_YOLOV3 CACHE)
  unset(ENABLE_LANDMARK CACHE)
  unset(ENABLE_FACEQUALITY5PT CACHE)
  unset(ENABLE_REID CACHE)
  unset(ENABLE_RETINAFACE CACHE)
  option(DISABLE_ALL "disable all libraries" ON)
  option(ENABLE_CLASSIFICATION "enable classification" ON)
  option(ENABLE_FACEDETECT "enable face detection" ON)
  option(ENABLE_FACEFEATURE "enable face feature" ON)
  option(ENABLE_YOLOV3 "enable Yolov3" ON)
  option(ENABLE_LANDMARK "enable landmark face-5pt" ON)
  option(ENABLE_FACEQUALITY5PT "enable face quality 5pt" ON)
  option(ENABLE_REID "enable reid" ON)
  option(ENABLE_RETINAFACE "enable face detection" ON)

  # Enable DPUV1 flag
  add_definitions(-DENABLE_DPUCADX8G_RUNNER)
endif()

if(ENABLE_DPUCADF8H_RUNNER)
  # Enble supported models for DPUV1
  unset(DISABLE_ALL CACHE)
  unset(ENABLE_CLASSIFICATION CACHE)
  option(DISABLE_ALL "disable all libraries" ON)
  option(ENABLE_CLASSIFICATION "enable classification" ON)
endif()

find_package(xir)
find_package(unilog)
find_package(
  vart
  COMPONENTS util
             xrt-device-handle
             buffer-object
             dpu-controller
             runner
             dpu-runner
             runner-assistant
             mem-manager
  REQUIRED)
find_package(Protobuf 3.4.0 REQUIRED)
find_package(Xrt MODULE)
find_package(OpenCV COMPONENTS opencv_core opencv_video opencv_videoio
                               opencv_imgproc opencv_imgcodecs opencv_highgui)
if(NOT OpenCV_FOUND)
  find_package(
    OpenCV_LIBS
    opencv_core
    opencv_video
    opencv_videoio
    opencv_imgproc
    opencv_imgcodecs
    opencv_highgui)
endif(NOT OpenCV_FOUND)

find_package(vart REQUIRED)

set(PACKAGE_COMPONENTS model_config math runner_helper dpu_task cpu_task xnnpp)
add_subdirectory(usefultools)

if(ENABLE_CLASSIFICATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS classification)
endif()

if(ENABLE_TFSSD OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS tfssd)
endif()

if(ENABLE_FACEDETECT OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS facedetect)
endif()

if(ENABLE_FACEFEATURE OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS facefeature)
endif()

if(ENABLE_LANEDETECT OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS lanedetect)
endif()

if(ENABLE_YOLOV2 OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS yolov2)
endif()

if(ENABLE_YOLOV3 OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS yolov3)
endif()

if(ENABLE_LANDMARK OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS facelandmark)
endif()

if(ENABLE_FACEQUALITY5PT OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS facequality5pt)
endif()

if(ENABLE_SSD OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS ssd)
endif()

if(ENABLE_SEGMENTATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS segmentation)
endif()

if(ENABLE_COVID19SEGMENTATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS covid19segmentation)
endif()

if(ENABLE_3DSEGMENTATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS 3Dsegmentation)
endif()

if(ENABLE_REFINEDET OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS refinedet)
endif()

if(ENABLE_OPENPOSE OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS openpose)
endif()

if(ENABLE_HOURGLASS OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS hourglass)
endif()

if(ENABLE_POSEDETECT OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS posedetect)
endif()

if(ENABLE_REID OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS reid)
endif()

if(ENABLE_REIDTRACKER OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS reidtracker)
endif()

if(ENABLE_MULTITASK OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS multitask)
endif()

if(ENABLE_PLATEDETECT OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS platedetect)
endif()

if(ENABLE_PLATENUM OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS platenum)
endif()

if(ENABLE_PLATERECOG OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS platerecog)
endif()

if(ENABLE_CARPLATERECOG OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS carplaterecog)
endif()

if(ENABLE_MEDICALSEGMENTATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS medicalsegmentation)
endif()

if(ENABLE_MEDICALDETECTION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS medicaldetection)
endif()

if(ENABLE_FACERECOG OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS facerecog)
endif()

if(ENABLE_FACEDETECTRECOG OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS facedetectrecog)
endif()

if(ENABLE_POINTPILLARS OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS pointpillars)
endif()

if(ENABLE_RETINAFACE OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS retinaface)
endif()

if(ENABLE_CIFAR10CLASSIFICATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS cifar10classification)
endif()

if(ENABLE_MNISTCLASSIFICATION OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS mnistclassification)
endif()

if(ENABLE_MEDICALSEGCELL OR (NOT DISABLE_ALL))
  list(APPEND PACKAGE_COMPONENTS medicalsegcell)
endif()

# NOTE: general1 refer to many other libs, so it must be the last components in
# the list
if(ENABLE_GENERAL OR (NOT DISABLE_ALL))
  # use general1 instead of general because general is a special target name in
  # cmake
  list(APPEND PACKAGE_COMPONENTS general1)
endif()

add_subdirectory(benchmark)
include_directories(benchmark/include)

if(ENABLE_OVERVIEW AND (NOT DISABLE_ALL))
  add_subdirectory(overview)
endif()

foreach(COMPONENT ${PACKAGE_COMPONENTS})
  add_subdirectory(${COMPONENT})
endforeach()

file(RELATIVE_PATH REL_INCLUDE_DIR
     ${CMAKE_INSTALL_PREFIX}/share/cmake/${PROJECT_NAME}
     ${CMAKE_INSTALL_PREFIX}/include)
set(CONF_INCLUDE_DIRS "\${${PROJECT_NAME}_CMAKE_DIR}/${REL_INCLUDE_DIR}")
configure_file(cmake/config.cmake.in
               "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake" @ONLY)

write_basic_package_version_file(
  "${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
              "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
        DESTINATION share/cmake/${PROJECT_NAME})

set(CPACK_PACKAGE_NAME "libvitis_ai_library")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "A runtime runner for vitis")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_README "${CMAKE_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/Copyright.txt")
set(CPACK_PACKAGE_VENDOR "Humanity")
set(CPACK_PACKAGE_VERSION_MAJOR ${CMAKE_PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${CMAKE_PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${CMAKE_PROJECT_VERSION_PATCH})
set(CPACK_PACKAGE_CONTACT "Hui Zhang<huizhang@xilinx.com>")
set(CPACK_PACKAGING_INSTALL_PREFIX "/usr")

set(CPACK_DEB_COMPONENT_INSTALL False)
set(CPACK_DEBIAN_PACKAGE_SECTION "devel")
set(CPACK_DEBIAN_ARCHIVE_TYPE "gnutar")
set(CPACK_DEBIAN_COMPRESSION_TYPE "gzip")
set(CPACK_DEBIAN_PACKAGE_PRIORITY "optional")
set(CPACK_DEBIAN_PACKAGE_DEPENDS "libvart (>=0.0.1)")
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
if(DEFINED ENV{BUILD_NUMBER})
  set(CPACK_DEBIAN_PACKAGE_RELEASE "r$ENV{BUILD_NUMBER}")
endif()
if(CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
  set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "arm64")
elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
  set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")
else()
  set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})
endif()

set(CPACK_RPM_COMPONENT_INSTALL False)
set(CPACK_RPM_PACKAGE_LICENSE "Apache")
set(CPACK_RPM_PACKAGE_GROUP "Development/Tools")
set(CPACK_RPM_COMPRESSION_TYPE "xz")
set(CPACK_RPM_PACKAGE_REQUIRES "libvart >= 0.0.1")
set(CPACK_RPM_FILE_NAME RPM-DEFAULT)
if(DEFINED ENV{BUILD_NUMBER})
  set(CPACK_RPM_PACKAGE_RELEASE "r$ENV{BUILD_NUMBER}")
endif()
set(CPACK_RPM_PACKAGE_ARCHITECTURE ${CMAKE_SYSTEM_PROCESSOR})

include(CPack)

=== AKS/examples/CMakeLists.txt ===
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.12)

project(examples VERSION 1.3.0)

if (DPU STREQUAL "dpucadx8g")
# Set source files of examples (non-video)
set (EXAMPLES_IMAGE
  facedetect.cpp
  googlenet.cpp
  googlenet_pp_accel.cpp
  googlenet_resnet50.cpp
  googlenet_tinyyolov3.cpp
  inception_v1_tf.cpp
  resnet50.cpp
  stdyolov2.cpp
  tinyyolov3.cpp
)
# Set source files of examples (video)
set (EXAMPLES_VIDEO
  tinyyolov3_video.cpp
)
elseif (DPU STREQUAL "dpucahx8h")
# Set source files of examples (non-video)
set (EXAMPLES_IMAGE
  resnet50_u50.cpp
)
# Set source files of examples (video)
set (EXAMPLES_VIDEO
  ""
)
elseif (DPU STREQUAL "dpuczdx8g")
# Set source files of examples (non-video)
set (EXAMPLES_IMAGE
  resnet50_edge.cpp
  )
# Set source files of examples (video)
set (EXAMPLES_VIDEO
  ""
)
elseif (DPU STREQUAL "dpucadf8h")
# Set source files of examples (non-video)
set (EXAMPLES_IMAGE
  resnet50_dpucadf8h.cpp
  )
# Set source files of examples (video)
set (EXAMPLES_VIDEO
  ""
)
else()
message (FATAL_ERROR "
  Nothing to build.
  Make sure to specify target DPU with \'--dpu\' option."
  )
endif()

# Find Packages
if (NOT "${AKS_INSTALL_PREFIX}" STREQUAL "")
  message(STATUS "AKS Install Prefix: ${AKS_INSTALL_PREFIX}")
  find_package(aks REQUIRED
    PATHS ${AKS_INSTALL_PREFIX}
    NO_DEFAULT_PATH
  )
else()
  find_package(aks REQUIRED
  )
endif()
message(STATUS "AKS Includes: ${aks_INCLUDE_DIRS}")

execute_process(COMMAND uname -m OUTPUT_VARIABLE arch)
find_package(Threads REQUIRED)
if(${arch} MATCHES ".*x86.*")
  find_package(Boost 1.65.1 EXACT REQUIRED COMPONENTS system filesystem)
else()
  find_package(Boost 1.65.1 REQUIRED COMPONENTS system filesystem)
endif()
find_package(OpenCV REQUIRED COMPONENTS core imgproc video videoio)

# Set output directories for executables
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_SOURCE_DIR}/bin)


# Compile Sources
foreach( sourcefile ${EXAMPLES_IMAGE} )
  # Generate executable name
  string( REPLACE ".cpp" ".exe" exename ${sourcefile} )

  # Set target
  add_executable( ${exename} ${sourcefile} )

  # Set include dirs
  target_include_directories (${exename}
    PRIVATE ${aks_INCLUDE_DIRS}
    PRIVATE ${Boost_INCLUDE_DIRS}
  )

  # Set libraries to be linked
  target_link_libraries (${exename}
    PRIVATE ${aks_LIBRARIES}
    PRIVATE ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY}
    PRIVATE ${CMAKE_DL_LIBS}
    PRIVATE ${CMAKE_THREAD_LIBS_INIT}
  )
  # set (CMAKE_DEBUG_TARGET_PROPERTIES INCLUDE_DIRECTORIES)
endforeach()


# Compile Sources
foreach( sourcefile ${EXAMPLES_VIDEO} )
  # Generate executable name
  string( REPLACE ".cpp" ".exe" exename ${sourcefile} )

  # Set target
  add_executable( ${exename} ${sourcefile} )

  # Set include dirs
  target_include_directories (${exename}
    PRIVATE ${aks_INCLUDE_DIRS}
    PRIVATE ${OpenCV_INCLUDE_DIRS}
  )

  # Set libraries to be linked
  target_link_libraries (${exename}
    PRIVATE ${aks_LIBRARIES}
    PRIVATE ${CMAKE_DL_LIBS}
    PRIVATE ${CMAKE_THREAD_LIBS_INIT}
    PRIVATE opencv_core opencv_imgproc opencv_video opencv_videoio
  )
  # set (CMAKE_DEBUG_TARGET_PROPERTIES INCLUDE_DIRECTORIES)
endforeach()

=== RNN/rnn_compiler/requirements.txt ===
numpy==1.17.2
tqdm
networkx

=== RNN/rnn_quantizer/CMakeLists.txt ===
IF (APPLE)
    cmake_minimum_required(VERSION 3.4)
ELSE()
    cmake_minimum_required(VERSION 2.8)
ENDIF()

project(nndct_release)

IF (NOT APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fopenmp -O2")
ENDIF()

IF (APPLE)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -O2")
    add_definitions(-DAPPLE)
ENDIF()

FIND_PACKAGE(CUDA 6.5)
MESSAGE(STATUS "cuda found ${CUDA_FOUND}")

option(WITH_GPU "compile nndct with cuda." ${CUDA_FOUND})
option(WITH_OMP "compile nndct with openmp." ON)

if(WITH_GPU)
	add_definitions(-DNNDCT_ENABLE_GPU)
endif()

if(NOT WITH_OMP)
	add_definitions(-DNNDCT_DISABLE_OMP)
endif()

# need to be at least 30 or __shfl_down in reduce wont compile
set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_30,code=sm_30 -O2")
set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_35,code=sm_35")

set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_50,code=sm_50")
set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_52,code=sm_52")

IF (CUDA_VERSION GREATER 7.6)
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_60,code=sm_60")
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_61,code=sm_61")
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_62,code=sm_62")
ENDIF()

IF (CUDA_VERSION GREATER 8.9)
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -gencode arch=compute_70,code=sm_70")
ENDIF()

if (NOT APPLE)
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} --std=c++11")
    set(CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -Xcompiler -fopenmp")
ENDIF()

IF (APPLE)
    EXEC_PROGRAM(uname ARGS -v  OUTPUT_VARIABLE DARWIN_VERSION)
    STRING(REGEX MATCH "[0-9]+" DARWIN_VERSION ${DARWIN_VERSION})
    MESSAGE(STATUS "DARWIN_VERSION=${DARWIN_VERSION}")

    #for el capitain have to use rpath

    IF (DARWIN_VERSION LESS 15)
        set(CMAKE_SKIP_RPATH TRUE)
    ENDIF ()

ELSE()
    #always skip for linux
    set(CMAKE_SKIP_RPATH TRUE)
ENDIF()


IF (WITH_GPU)

    MESSAGE(STATUS "Building shared library with GPU support")
    
    FILE(GLOB_RECURSE CC_LIST ./csrc/*.cc)
    FILE(GLOB_RECURSE CU_LIST ./csrc/*.cu)
    CUDA_ADD_LIBRARY(nndct SHARED ${CC_LIST} ${CU_LIST})

    TARGET_LINK_LIBRARIES(nndct ${CUDA_curand_LIBRARY})

    INSTALL(TARGETS nndct
            RUNTIME DESTINATION "bin"
            LIBRARY DESTINATION "lib"
            ARCHIVE DESTINATION "lib")

ELSE()
    MESSAGE(STATUS "Building shared library with no GPU support")

ENDIF()

=== RNN/rnn_quantizer/requirements.txt ===
torch >= 1.1.0
torchvision >=0.3.0
sklearn
scipy==1.3.1
numpy==1.17.2
tqdm
ninja

=== Vitis-AI-Library/3Dsegmentation/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
cmake_minimum_required(VERSION 3.5)
get_filename_component(COMPONENT_NAME "${CMAKE_CURRENT_SOURCE_DIR}" NAME)
include(XilinxVersion)
add_library(${COMPONENT_NAME} SHARED
  include/vitis/ai/3Dsegmentation.hpp
  src/3Dsegmentation.cpp
  src/3Dsegmentation_imp.hpp
  src/3Dsegmentation_imp.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/version.c
  )
add_library(${PROJECT_NAME}::${COMPONENT_NAME} ALIAS ${COMPONENT_NAME})

target_link_libraries(${COMPONENT_NAME} ${PROJECT_NAME}::xnnpp ${PROJECT_NAME}::dpu_task)

target_include_directories(${COMPONENT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)

target_include_directories(${COMPONENT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<INSTALL_INTERFACE:include>
)

set_target_properties(${COMPONENT_NAME} PROPERTIES
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  LIBRARY_OUTPUT_NAME  ${PROJECT_NAME}-${COMPONENT_NAME}
  )
install(
  TARGETS ${COMPONENT_NAME}
  EXPORT ${COMPONENT_NAME}-targets
  RUNTIME DESTINATION ${INSTALL_BIN_DIR}
  LIBRARY DESTINATION ${INSTALL_LIB_DIR})

install(
  EXPORT ${COMPONENT_NAME}-targets
  NAMESPACE ${PROJECT_NAME}::
  DESTINATION ${INSTALL_CMAKE_DIR})
install(FILES include/vitis/ai/3Dsegmentation.hpp
  DESTINATION include/vitis/ai)

add_executable(test_3Dsegmentation test/test_3Dsegmentation.cpp)
target_link_libraries(test_3Dsegmentation ${COMPONENT_NAME})

add_executable(test_3Dsegmentation_batch test/test_3Dsegmentation_batch.cpp)
target_link_libraries(test_3Dsegmentation_batch ${COMPONENT_NAME})

#add_executable(test_3Dsegmentation_accuracy test/test_3Dsegmentation_accuracy.cpp)
#target_link_libraries(test_3Dsegmentation_accuracy ${COMPONENT_NAME} math)

=== Vitis-AI-Library/benchmark/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
cmake_minimum_required(VERSION 3.5)
get_filename_component(COMPONENT_NAME "${CMAKE_CURRENT_SOURCE_DIR}" NAME)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SYSROOT}/usr/share/cmake/")
include(XilinxCommon)
include(XilinxVersion)
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")

install(FILES
  include/vitis/ai/benchmark.hpp
  include/vitis/ai/image_list.hpp
  include/vitis/ai/stat_samples.hpp
  DESTINATION include/vitis/ai
  )

install(FILES
  include/vitis/ai/demo.hpp
  include/vitis/ai/demo_accuracy.hpp
  include/vitis/ai/dpdrm.hpp
  DESTINATION include/vitis/ai
  )

=== Vitis-AI-Library/carplaterecog/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
cmake_minimum_required(VERSION 3.5)
get_filename_component(COMPONENT_NAME "${CMAKE_CURRENT_SOURCE_DIR}" NAME)
include(XilinxVersion)
add_library(${COMPONENT_NAME} SHARED
  include/vitis/ai/carplaterecog.hpp
  src/carplaterecog.cpp
  src/carplaterecog_imp.hpp
  src/carplaterecog_imp.cpp
  ${CMAKE_CURRENT_BINARY_DIR}/version.c
  )
add_library(${PROJECT_NAME}::${COMPONENT_NAME} ALIAS ${COMPONENT_NAME})
target_link_libraries(${COMPONENT_NAME}
  ${PROJECT_NAME}::platerecog
  ${PROJECT_NAME}::ssd
  ${OpenCV_LIBS} # cv::resize
  glog::glog
  )
target_link_libraries(${COMPONENT_NAME} xir::xir) 
target_include_directories(${COMPONENT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)

target_include_directories(${COMPONENT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<INSTALL_INTERFACE:include>
)

set_target_properties(${COMPONENT_NAME} PROPERTIES
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  LIBRARY_OUTPUT_NAME  ${PROJECT_NAME}-${COMPONENT_NAME}
  )
install(
  TARGETS ${COMPONENT_NAME}
  EXPORT ${COMPONENT_NAME}-targets
  RUNTIME DESTINATION ${INSTALL_BIN_DIR}
  LIBRARY DESTINATION ${INSTALL_LIB_DIR})

install(
  EXPORT ${COMPONENT_NAME}-targets
  NAMESPACE ${PROJECT_NAME}::
  DESTINATION ${INSTALL_CMAKE_DIR})
install(FILES include/vitis/ai/carplaterecog.hpp
  DESTINATION include/vitis/ai)

add_executable(test_carplaterecog test/test_carplaterecog.cpp)
target_link_libraries(test_carplaterecog ${COMPONENT_NAME})
add_executable(test_carplaterecog_batch test/test_carplaterecog_batch.cpp)
target_link_libraries(test_carplaterecog_batch ${COMPONENT_NAME})

=== Vitis-AI-Library/cifar10classification/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
cmake_minimum_required(VERSION 3.5)
get_filename_component(COMPONENT_NAME "${CMAKE_CURRENT_SOURCE_DIR}" NAME)
set(OpenCV_LIBS opencv_core opencv_video opencv_videoio opencv_imgproc opencv_imgcodecs opencv_highgui)

if(CMAKE_SYSTEM_NAME STREQUAL "QNX")
  ## TODO: fix hard coded directory
  link_directories(/home/administrator/workspace/qtbase/lib/)
  list(APPEND OpenCV_LIBS Qt5Widgets Qt5Test Qt5Concurrent Qt5Gui Qt5Core)
else()
  list(APPEND OpenCV_LIBS pthread)
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SYSROOT}/usr/share/cmake/")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include")
include(XilinxCommon)
include(XilinxVersion)

add_library(${COMPONENT_NAME} SHARED
  include/vitis/ai/cifar10classification.hpp
  src/cifar10classification.cpp
  src/cifar10classification_imp.cpp
  src/cifar10classification_imp.hpp
  ${CMAKE_CURRENT_BINARY_DIR}/version.c
  )
add_library(${PROJECT_NAME}::${COMPONENT_NAME} ALIAS ${COMPONENT_NAME})
target_link_libraries(${COMPONENT_NAME} model_config dpu_task xnnpp glog::glog pthread ${OpenCV_LIBS})
target_include_directories(${COMPONENT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)

target_include_directories(${COMPONENT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<INSTALL_INTERFACE:include>
)

set_target_properties(${COMPONENT_NAME} PROPERTIES
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  LIBRARY_OUTPUT_NAME  ${PROJECT_NAME}-${COMPONENT_NAME}
  )
install(
  TARGETS ${COMPONENT_NAME}
  EXPORT ${COMPONENT_NAME}-targets
  RUNTIME DESTINATION ${INSTALL_BIN_DIR}
  LIBRARY DESTINATION ${INSTALL_LIB_DIR})

install(
  EXPORT ${COMPONENT_NAME}-targets
  NAMESPACE ${PROJECT_NAME}::
  DESTINATION ${INSTALL_CMAKE_DIR})

install(FILES include/vitis/ai/cifar10classification.hpp DESTINATION include/vitis/ai)

add_executable(test_cifar10classification test/test_cifar10classification.cpp)
target_link_libraries(test_cifar10classification ${COMPONENT_NAME} glog::glog  ${OpenCV_LIBS})

add_executable(test_cifar10classification_batch test/test_cifar10classification_batch.cpp)
target_link_libraries(test_cifar10classification_batch ${COMPONENT_NAME} glog::glog  ${OpenCV_LIBS})

=== Vitis-AI-Library/classification/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
cmake_minimum_required(VERSION 3.5)
get_filename_component(COMPONENT_NAME "${CMAKE_CURRENT_SOURCE_DIR}" NAME)

include(XilinxCommon)
include(XilinxVersion)

add_library(${COMPONENT_NAME} SHARED
  include/vitis/ai/classification.hpp
  src/classification.cpp
  src/classification_imp.cpp
  src/classification_imp.hpp
  ${CMAKE_CURRENT_BINARY_DIR}/version.c
  )

add_library(${PROJECT_NAME}::${COMPONENT_NAME} ALIAS ${COMPONENT_NAME})

target_link_libraries(${COMPONENT_NAME} ${PROJECT_NAME}::xnnpp ${PROJECT_NAME}::dpu_task ${PROJECT_NAME}::model_config ${OpenCV_LIBS} ${PROJECT_NAME}::math)

target_include_directories(${COMPONENT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)

target_include_directories(${COMPONENT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<INSTALL_INTERFACE:include>
)

set_target_properties(${COMPONENT_NAME} PROPERTIES
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  LIBRARY_OUTPUT_NAME  ${PROJECT_NAME}-${COMPONENT_NAME}
  )

install(
  TARGETS ${COMPONENT_NAME}
  EXPORT ${COMPONENT_NAME}-targets
  RUNTIME DESTINATION ${INSTALL_BIN_DIR}
  LIBRARY DESTINATION ${INSTALL_LIB_DIR})

install(
  EXPORT ${COMPONENT_NAME}-targets
  NAMESPACE ${PROJECT_NAME}::
  DESTINATION ${INSTALL_CMAKE_DIR})

install(FILES include/vitis/ai/classification.hpp DESTINATION include/vitis/ai)

add_executable(test_classification test/test_classification.cpp)
add_executable(test_classification_batch test/test_classification_batch.cpp)
add_executable(test_classification_accuracy test/test_accuracy_classification.cpp)
add_executable(test_classification_speed test/test_classification_speed.cpp)
add_executable(test_classification_accuracy_mt test/test_accuracy_classification_mt.cpp)
target_link_libraries(test_classification ${COMPONENT_NAME} ${OpenCV_LIBS})
target_link_libraries(test_classification_batch ${COMPONENT_NAME} ${OpenCV_LIBS})
target_link_libraries(test_classification_accuracy ${COMPONENT_NAME} ${OpenCV_LIBS} protobuf::libprotobuf)
target_link_libraries(test_classification_speed ${COMPONENT_NAME} ${OpenCV_LIBS})
target_link_libraries(test_classification_accuracy_mt ${COMPONENT_NAME} ${OpenCV_LIBS} -lpthread -lglog protobuf::libprotobuf)

=== Vitis-AI-Library/covid19segmentation/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
cmake_minimum_required(VERSION 3.5)
get_filename_component(COMPONENT_NAME "${CMAKE_CURRENT_SOURCE_DIR}" NAME)

set(OpenCV_LIBS opencv_core opencv_video opencv_videoio opencv_imgproc opencv_imgcodecs opencv_highgui)
if(CMAKE_SYSTEM_NAME STREQUAL "QNX")
  ## TODO: fix hard coded directory
  link_directories(/home/administrator/workspace/qtbase/lib/)
  list(APPEND OpenCV_LIBS Qt5Widgets Qt5Test Qt5Concurrent Qt5Gui Qt5Core)
else()
endif()

include(XilinxCommon)
include(XilinxVersion)
#include(XilinxDpu)
add_library(${COMPONENT_NAME} SHARED
  include/vitis/ai/covid19segmentation.hpp
  src/covid19segmentation.cpp
  src/covid19segmentation_imp.cpp
  src/covid19segmentation_imp.hpp
  ${CMAKE_CURRENT_BINARY_DIR}/version.c
  )
add_library(${PROJECT_NAME}::${COMPONENT_NAME} ALIAS ${COMPONENT_NAME})
target_link_libraries(${COMPONENT_NAME} ${PROJECT_NAME}::xnnpp ${PROJECT_NAME}::dpu_task)
target_include_directories(${COMPONENT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
target_include_directories(${COMPONENT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
  $<INSTALL_INTERFACE:include>
)
set_target_properties(${COMPONENT_NAME} PROPERTIES
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  LIBRARY_OUTPUT_NAME  ${PROJECT_NAME}-${COMPONENT_NAME}
  )
install(
  TARGETS ${COMPONENT_NAME}
  EXPORT ${COMPONENT_NAME}-targets
  RUNTIME DESTINATION ${INSTALL_BIN_DIR}
  LIBRARY DESTINATION ${INSTALL_LIB_DIR})

install(
  EXPORT ${COMPONENT_NAME}-targets
  NAMESPACE ${PROJECT_NAME}::
  DESTINATION ${INSTALL_CMAKE_DIR})

install(FILES include/vitis/ai/covid19segmentation.hpp DESTINATION include/vitis/ai)

add_executable(test_covid19segmentation test/test_covid19segmentation.cpp)
add_executable(test_covid19segmentation_batch test/test_covid19segmentation_batch.cpp)
target_link_libraries(test_covid19segmentation ${COMPONENT_NAME} ${OpenCV_LIBS})
target_link_libraries(test_covid19segmentation_batch ${COMPONENT_NAME} ${OpenCV_LIBS})
#add_executable(test_covid19segmentation_accuracy  test/test_accuracy_covid19segmentation.cpp)
#target_link_libraries(test_covid19segmentation_accuracy ${COMPONENT_NAME} ${OpenCV_LIBS} model_config)

=== Vitis-AI-Library/cpu_task/CMakeLists.txt ===
#
# Copyright 2019 Xilinx Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
get_filename_component(COMPONENT_NAME "${CMAKE_CURRENT_SOURCE_DIR}" NAME)
add_library(${COMPONENT_NAME} SHARED
  include/vart/op_imp.h
  src/cpu_task.hpp
  src/cpu_task.cpp
  src/op_imp.cpp
  src/batch_tensor_buffer_view.hpp
  src/batch_tensor_buffer_view.cpp
  )
add_library(${PROJECT_NAME}::${COMPONENT_NAME} ALIAS ${COMPONENT_NAME})
target_link_libraries(${COMPONENT_NAME} vart::runner ${PROJECT_NAME}::runner_helper vart::mem-manager dl)
target_include_directories(${COMPONENT_NAME} PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
set_target_properties(${COMPONENT_NAME} PROPERTIES
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  LIBRARY_OUTPUT_NAME  ${PROJECT_NAME}-${COMPONENT_NAME}
  )
install(
  TARGETS ${COMPONENT_NAME}
  EXPORT ${COMPONENT_NAME}-targets
  RUNTIME DESTINATION ${INSTALL_BIN_DIR}
  LIBRARY DESTINATION ${INSTALL_LIB_DIR})

install(
  EXPORT ${COMPONENT_NAME}-targets
  NAMESPACE ${PROJECT_NAME}::
  DESTINATION ${INSTALL_CMAKE_DIR})

macro(ADD_OP_IMP OP_TYPE)
  add_library(${OP_TYPE} SHARED ${ARGN})
  target_link_libraries(${OP_TYPE} ${COMPONENT_NAME})
  set_target_properties(${OP_TYPE} PROPERTIES
    LIBRARY_OUTPUT_NAME vart_op_imp_${OP_TYPE}
    )
  target_include_directories(${OP_TYPE} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
    )
  install(
    TARGETS ${OP_TYPE}
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    )
endmacro()

add_op_imp (softmax ops/softmax/softmax.cpp)
add_op_imp (fix2float ops/fix2float/fix2float.cpp)
add_op_imp (fix ops/fix/fix.cpp)

add_executable (test_cpu_task test/test_cpu_task.cpp)
target_link_libraries (test_cpu_task vart::runner  ${PROJECT_NAME}::runner_helper  vart::util)

=== debian/changelog ===
vitis-ai (1.3.2-0ubuntu7) impish; urgency=medium

  * Build with -Wno-error=range-loop-construct and -D_GLIBCXX_USE_NANOSLEEP
    to fix build failure with gcc-11.
  * debian/patches/gcc-11-sleep_for.patch: #include <thread>.
  * debian/patches/nonnull.patch: fix dereferences of null pointers.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 26 Aug 2021 13:59:44 -0700

vitis-ai (1.3.2-0ubuntu6) impish; urgency=medium

  * Build-depend on libboost-filesystem-dev instead of using a versioned
    dependency.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 26 Aug 2021 15:39:36 +0000

vitis-ai (1.3.2-0ubuntu5) hirsute; urgency=medium

  * debian/vitis-ai-runtime.links, debian/vitis-ai-runtime.install: Do not
    install any subdirectories into /usr/bin and use /usr/lib instead, with
    the vaitrace symlink modified.
  * Cleanup patches and copyright.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Wed, 14 Apr 2021 15:00:34 +0200

vitis-ai (1.3.2-0ubuntu4) hirsute; urgency=medium

  * Workaround duplicate definition of SSDOutputInfo

 -- Alfonso Sanchez-Beato (email Canonical) <alfonso.sanchez-beato@canonical.com>  Tue, 13 Apr 2021 17:55:06 +0200

vitis-ai (1.3.2-0ubuntu3) hirsute; urgency=medium

  * Add watch file and fix lintian warnings

 -- Alfonso Sanchez-Beato (email Canonical) <alfonso.sanchez-beato@canonical.com>  Mon, 12 Apr 2021 14:42:07 +0200

vitis-ai (1.3.2-0ubuntu2) hirsute; urgency=medium

  * Rebuild for hirsute

 -- Alfonso Sanchez-Beato (email Canonical) <alfonso.sanchez-beato@canonical.com>  Thu, 25 Mar 2021 11:48:21 +0100

vitis-ai (1.3.2-0ubuntu1) focal; urgency=medium

  * Update to 1.3.2

 -- Alfonso Sanchez-Beato (email Canonical) <alfonso.sanchez-beato@canonical.com>  Wed, 24 Mar 2021 17:54:55 +0100

vitis-ai (1.3-1ubuntu2) focal; urgency=medium

  * Change cross-compile option to is_edge.
    Vitis AI thinks that edge <-> cross compile. Fix it to allow local
    builds, by using a new cmake variable called IS_EDGE to determine
    whether this is an edge platform or not, instead of the cmake internal
    variable CMAKE_CROSSCOMPILING.

 -- Alfonso Sanchez-Beato (email Canonical) <alfonso.sanchez-beato@canonical.com>  Mon, 18 Jan 2021 15:13:06 +0100

vitis-ai (1.3-1ubuntu1) focal; urgency=medium

  * Build from v1.3 tag from https://github.com/Xilinx/Vitis-AI

 -- Alfonso Sanchez-Beato (email Canonical) <alfonso.sanchez-beato@canonical.com>  Thu, 07 Jan 2021 15:48:45 +0100

=== debian/control ===
Source: vitis-ai
Section: libdevel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper-compat (= 12),
               cmake,
               libboost-filesystem-dev,
               libeigen3-dev,
               libgtest-dev,
               libgoogle-glog-dev,
               libjson-c-dev,
               libopencv-dev,
               libprotobuf-dev,
               libssl-dev,
               lsb-release,
               pkg-config,
               protobuf-compiler,
               xrt-embedded,
               uuid-dev,
Standards-Version: 4.5.0

Package: vitis-ai-runtime
Architecture: arm64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Vitis AI runtime
 Vitis AI Run time enables applications to use the unified high-level
 runtime API for both cloud and edge. Therefore, making cloud-to-edge
 deployments seamless and efficient.
 The Vitis AI Runtime API features are:
 * Asynchronous submission of jobs to the accelerator
 * Asynchronous collection of jobs from the accelerator
 * C++ and Python implementations
 * Support for multi-threading and multi-process execution
 .
 This package contains the Vitis AI runtime libraries, headers, and tools.

Package: vitis-ai-library
Architecture: arm64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Vitis AI library
 The Vitis AI Library is a set of high-level libraries and APIs built for
 efficient AI inference with Deep-Learning Processor Unit (DPU). It is
 built based on the Vitis AI Runtime with Unified APIs, and it fully
 supports XRT 2020.2.
 .
 The Vitis AI Library provides an easy-to-use and unified interface by
 encapsulating many efficient and high-quality neural networks. This
 simplifies the use of deep-learning neural networks, even for users
 without knowledge of deep-learning or FPGAs. The Vitis AI Library allows
 users to focus more on the development of their applications, rather
 than the underlying hardware.

Package: vitis-ai-dnndk
Architecture: arm64
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Vitis AI DNNDK runtime
 The Vitis AI DNNDK runtime is a set of libraries used to configure
 Xilinx DPU on Zynq devices.
 .
 This package contains the Vitis AI DNNDK libraries, headers, and tools.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CXXFLAGS_MAINT_APPEND := -Wno-error=range-loop-construct

%:
	dh $@ --with autoreconf

override_dh_auto_build:
	cd tools/Vitis-AI-Runtime/VART/unilog; \
	    ./cmake.sh --type=release \
	        --cmake-options -DIS_EDGE=TRUE \
	        --build-dir=$(CURDIR)/debian/build-unilog/ \
	        --install-prefix=$(CURDIR)/debian/tmp/usr/ \
	        --cmake-options='-DBUILD_TEST=OFF'
	cd tools/Vitis-AI-Runtime/VART/xir; \
	    ./cmake.sh --type=release \
	        --cmake-options -DIS_EDGE=TRUE \
	        --build-dir=$(CURDIR)/debian/build-xir/ \
	        --install-prefix=$(CURDIR)/debian/tmp/usr/ \
	        --cmake-options='-DBUILD_TEST=OFF'
	cd tools/Vitis-AI-Runtime/VART/target_factory; \
	    ./cmake.sh --type=release \
	        --cmake-options -DIS_EDGE=TRUE \
	        --build-dir=$(CURDIR)/debian/build-target_factory/ \
                --install-prefix=$(CURDIR)/debian/tmp/usr/ \
	        --cmake-options='-DBUILD_TEST=OFF'
	cd tools/Vitis-AI-Runtime/VART/vart; \
	    ./cmake.sh --type=release \
	        --cmake-options -DIS_EDGE=TRUE \
	        --build-dir=$(CURDIR)/debian/build-vart/ \
                --install-prefix=$(CURDIR)/debian/tmp/usr/ \
	        --cmake-options='-DBUILD_TEST=OFF -DENABLE_DPU_RUNNER=ON -DENABLE_CPU_RUNNER=OFF -DENABLE_SIM_RUNNER=OFF'
	cd tools/Vitis-AI-Library; \
	    ./cmake.sh --type=release \
	        --cmake-options '-DBUILD_TEST=OFF -DIS_EDGE=TRUE' \
	        --build-dir=$(CURDIR)/debian/build-library/ \
	        --install-prefix=$(CURDIR)/debian/tmp/usr/
	cd tools/Vitis-AI-Runtime/DNNDK; \
	    $(MAKE) -j$(shell nproc)

override_dh_auto_install:
	cd tools/Vitis-AI-Runtime/DNNDK; \
	    $(MAKE) DESTDIR=$(CURDIR)/debian/tmp install

override_dh_auto_clean:
	rm -rf $(CURDIR)/debian/build-*

# dh_prep removes debian/tmp, and we do not want that
override_dh_prep:
